SystemOrganization addCategory: #'Pier-Documents'!

!PRStructure methodsFor: '*pier-documents-accessing' stamp: 'lr 11/13/2007 13:54'!
documents
	"Answer some additional documents to be displayed and edited using the PRDocumentWidget."
	
	^ self propertyAt: #documents ifAbsentPut: [ Dictionary new ]! !

PRWidget subclass: #PRDocumentWidget
	instanceVariableNames: 'specification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Documents'!

!PRDocumentWidget class methodsFor: 'accessing-descriptions' stamp: 'lr 4/10/2008 14:17'!
descriptionDefault
	^ PRDocumentDescription new
		accessor: #default;
		label: 'Default';
		priority: 120;
		yourself! !

!PRDocumentWidget class methodsFor: 'accessing-descriptions' stamp: 'lr 4/10/2008 14:17'!
descriptionInherited
	^ MABooleanDescription new
		accessor: #inherited;
		label: 'Inherited';
		default: false;
		priority: 110;
		beRequired;
		yourself! !

!PRDocumentWidget class methodsFor: 'testing' stamp: 'lr 10/17/2007 22:17'!
isAbstract
	^ false! !

!PRDocumentWidget class methodsFor: 'accessing' stamp: 'lr 10/17/2007 22:17'!
label
	^ 'Document'! !

!PRDocumentWidget methodsFor: 'private' stamp: 'lr 11/13/2007 16:37'!
buildSpecification
	^ self class descriptionDefault
		accessor: (MAChainAccessor
			accessor: (MASelectorAccessor selector: #documents)
			next: (MADictionaryAccessor key: self owner name));
		yourself! !

!PRDocumentWidget methodsFor: 'accessing' stamp: 'lr 2/14/2008 13:38'!
children
	^ (PROutgoingReferences on: self document) embeddedComponents
		collect: [ :each | self context componentAt: each ]! !

!PRDocumentWidget methodsFor: 'accessing-settings' stamp: 'lr 10/28/2007 12:53'!
default
	"Answer the default document of the receiver."
	
	^ self read: #descriptionDefault! !

!PRDocumentWidget methodsFor: 'accessing' stamp: 'lr 10/28/2007 12:52'!
document
	^ self documentOf: self context structure! !

!PRDocumentWidget methodsFor: 'accessing' stamp: 'lr 11/13/2007 13:37'!
documentOf: aStructure
	"Answer the document to be displayed."

	^ (self specification accessor read: aStructure) ifNil: [
		(self inherited and: [ aStructure parent notNil ])
			ifTrue: [ self documentOf: aStructure parent ]
			ifFalse: [ self default ] ]! !

!PRDocumentWidget methodsFor: 'accessing-settings' stamp: 'lr 10/28/2007 12:53'!
inherited
	"Answer whether the document should be inherited or not."
	
	^ self read: #descriptionInherited! !

!PRDocumentWidget methodsFor: 'rendering' stamp: 'lr 10/28/2007 11:58'!
renderContentOn: html
	self context command isEdit
		ifTrue: [ self renderEditOn: html ]
		ifFalse: [ self renderViewOn: html ]! !

!PRDocumentWidget methodsFor: 'rendering' stamp: 'lr 11/13/2007 16:40'!
renderEditOn: html
	| id |
	html textArea
		value: self text;
		class: 'wiki-inline';
		id: (id := html nextId);
		callback: [ :value | self text: value ];
		onChange: (html request triggerFormElement: id).
	(PRCompatibility classNamed: #PREditorScripts) isNil
		ifFalse: [ html script: 'new EditorEnh(' , id printString , ',{toolbar: false})' ]! !

!PRDocumentWidget methodsFor: 'rendering' stamp: 'lr 11/13/2007 14:07'!
renderViewOn: html
	self renderer withinContentDo: [ self renderer continue: self document in: self on: html ]! !

!PRDocumentWidget methodsFor: 'accessing' stamp: 'lr 10/17/2007 22:40'!
renderer
	^ self context renderer! !

!PRDocumentWidget methodsFor: 'accessing' stamp: 'lr 11/13/2007 13:36'!
specification
	"Answer a description representing the receiving document."
	
	^ specification ifNil: [ specification := self buildSpecification ]! !

!PRDocumentWidget methodsFor: 'accessing-editing' stamp: 'lr 11/13/2007 13:48'!
text
	^ self specification 
		toString: (self context command fields 
			at: self specification
			ifAbsentPut: [ 
				self specification accessor
					read: self context structure ])! !

!PRDocumentWidget methodsFor: 'accessing-editing' stamp: 'lr 11/13/2007 14:27'!
text: aString
	| document |
	document := self specification fromString: aString.
	document isNil
		ifFalse: [ document owner: self context structure ].
	self context command fields
		at: self specification
		put: document! !
